#include "core/utils/Error.hpp"

size_t Core::toString(Error e, char* buffer, size_t size) {
    size_t written = 0;
    Error::Code c = e.code;
    for(size_t i = size; i > 1; i--) {
        *(buffer++) = (c & 1) ? '1' : '0';
        written++;
        c >>= 1;
        if(c == 0) {
            break;
        }
    }
    *buffer = '\0';
    while(c != 0) {
        written++;
        c >>= 1;
    }
    return written;
}
