#ifndef CORE_ERROR_SIMULATOR_H
#define CORE_ERROR_SIMULATOR_H

#ifdef ERROR_SIMULATOR
extern bool failTimeGet;
extern bool failThreadInit;
extern bool failThreadJoin;
extern bool failMutexInit;
extern bool failMutexLock;
extern bool failMutexUnlock;
extern int failStep;
#define TIME_GET_FAIL failTimeGet
#define THREAD_INIT_FAIL failThreadInit
#define THREAD_JOIN_FAIL failThreadJoin
#define MUTEX_INIT_FAIL failMutexInit
#define MUTEX_LOCK_FAIL failMutexLock
#define MUTEX_UNLOCK_FAIL failMutexUnlock
#define FAIL_STEP (--failStep == 0)
#else
#define TIME_GET_FAIL false
#define THREAD_INIT_FAIL false
#define THREAD_JOIN_FAIL false
#define MUTEX_INIT_FAIL false
#define MUTEX_LOCK_FAIL false
#define MUTEX_UNLOCK_FAIL false
#define FAIL_STEP false
#endif

#endif
